<?php
  if (function_exists('register_sidebar')) {
    register_sidebar();
    register_sidebar();
    register_sidebar(array('name'=>'Royale Top'));
    register_sidebar(array('name'=>'Royale Bottom'));
  }
  load_theme_textdomain('royale');

  // Set default values
  if (!get_option('royale_hue'))             update_option('royale_hue'            , 201               );
  if (!get_option('royale_rgb1'))            update_option('royale_rgb1'           , 'rgb(21,159,233)' );
  if (!get_option('royale_rgb2'))            update_option('royale_rgb2'           , 'rgb(128,210,255)');
  if (!get_option('royale_overlay_opacity')) update_option('royale_overlay_opacity', 25                );
  if (!get_option('royale_bgpattern'))       update_option('royale_bgpattern'      , 'default.png'     );

  if (!get_option('royale_title_scheme_index'   )) update_option('royale_title_scheme_index'   ,'%blogname% - %tagline%');
  if (!get_option('royale_title_scheme_single'  )) update_option('royale_title_scheme_single'  ,'%blogname% &raquo; %post%');
  if (!get_option('royale_title_scheme_page'    )) update_option('royale_title_scheme_page'    ,'%blogname% &raquo; %post%');
  if (!get_option('royale_title_scheme_category')) update_option('royale_title_scheme_category','%blogname% &raquo; Archive for %category%');
  if (!get_option('royale_title_scheme_date'    )) update_option('royale_title_scheme_date'    ,'%blogname% &raquo; Archive for %date%');
  if (!get_option('royale_title_scheme_search'  )) update_option('royale_title_scheme_search'  ,'%blogname% &raquo; Search Results for &quot;%search%&quot;');



  // some global vars
  $ie     = preg_match("/MSIE [4-6]/",$_SERVER['HTTP_USER_AGENT']);
  $ie7    = preg_match("/MSIE 7/",    $_SERVER['HTTP_USER_AGENT']);
  $wpmu   = function_exists('is_site_admin');



  function mkicon($class,$alt) {
    return '<img src="'. get_bloginfo('stylesheet_directory') .'/images/1x1.gif" class="icon '. $class .'" alt="'. $alt .'" />';
  }



  // SEARCH WIDGET
  function widget_royale_search() {
?>
			<li><h2><?php _e('Search','royale'); ?></h2>
				<?php include (TEMPLATEPATH . '/searchform.php'); ?>
			</li>
<?php
  }
  if (function_exists('register_sidebar_widget')) register_sidebar_widget('Search','widget_royale_search');




  // CALENDAR WIDGET
  function widget_royale_calendar() {
?>
			<li><h2>&nbsp;</h2>
				<?php get_calendar(); ?>
			</li>
<?php
  }
  if (function_exists('register_sidebar_widget')) register_sidebar_widget('Calendar','widget_royale_calendar');




  // META WIDGET
  function widget_royale_meta() {
    $options = get_option('widget_meta');
    $title = empty($options['title']) ? __('Meta','royale') : $options['title'];
?>
				<li><h2><?php echo $title; ?></h2>
				<ul>
					<?php wp_register(); ?>
					<li><?php wp_loginout(); ?></li>
					<li><a href="feed:<?php bloginfo('rss2_url'); ?>" title="RSS feed for <?php bloginfo('name'); ?>">Entries</a> &nbsp; <?php echo mkicon('rss absolute',''); ?></li>
					<li><a href="http://wordpress.org/" title="Powered by WordPress, state-of-the-art semantic personal publishing platform.">WordPress</a></li>
					<li><a href="http://www.onehertz.com/portfolio/wordpress/" title="Other Wordpress themes by the same author" target="_blank">Royale theme</a></li>
					<?php wp_meta(); ?>
				</ul>
				</li>
<?php
  }
  if (function_exists('register_sidebar_widget')) register_sidebar_widget('Meta','widget_royale_meta');




  // ADMIN
  add_action('admin_menu', 'add_royale_options_page');
  add_action('admin_menu', 'add_royale_inserts_page');
  add_action('admin_menu', 'add_royale_readme_page');

  function add_royale_options_page() { add_theme_page('Theme Options', '<img src="'. get_bloginfo('template_directory') .'/images/attention_catcher.png" /> Theme Options', 'edit_themes', basename(__FILE__), 'royale_options_page'); }
  function add_royale_inserts_page() { add_theme_page('HTML Inserts', '<img src="'. get_bloginfo('template_directory') .'/images/attention_catcher.png" /> HTML Inserts', 'edit_themes', 'Inserts', 'royale_inserts_page'); }
  function add_royale_readme_page()  { add_theme_page('README', 'README', 'switch_themes', 'README', 'royale_readme_page'); }

  function royale_set_var($var,$value)      { update_option('royale_'.$var,         $value); }
  function royale_set_exclude_pages($value) { update_option('royale_exclude_pages', $value); }
  function royale_escape($string)      {
    $string = str_replace('\\"','&#34;',$string);
    $string = str_replace("\\'",'&#39;',$string);
    return $string;
  }

  function royale_options_page() {
    global $ie, $ie7;
    if ($_GET['page'] == basename(__FILE__)) {
      $ct = current_theme_info();

      if (isset($_POST['updated'])) {
        royale_set_var('dates',$_POST['dates']);

        $exclude[] = '';
        foreach ($_POST as $field => $value) {
          if (preg_match("/exclude_(\d+)/",$field,$id)) { $exclude[] = $id[1]; }
        }

        royale_set_exclude_pages(implode(",",$exclude));
        royale_set_var('bold_links'          ,$_POST['boldlinks']        );
        royale_set_var('nofloat'             ,$_POST['nofloat']          );
        royale_set_var('footer_stats'        ,$_POST['footstats']        );
        royale_set_var('3columns'            ,$_POST['col3']             );
        royale_set_var('sidebar1_left'       ,$_POST['sidebar1']         );
        royale_set_var('sidebar2_left'       ,$_POST['sidebar2']         );
        royale_set_var('hue_cycle'           ,$_POST['cycle']            );
        royale_set_var('em_italics'          ,$_POST['em']               );
        royale_set_var('hue'                 ,$_POST['hue']              );
        royale_set_var('rgb1'                ,$_POST['rgb1']             );
        royale_set_var('rgb2'                ,$_POST['rgb2']             );
        royale_set_var('overlay_opacity'     ,$_POST['overlay_opacity']  );
        royale_set_var('bgpattern'           ,$_POST['bgpattern']        );
        royale_set_var('full_search_results' ,$_POST['fullsearchresults']);
        royale_set_var('always_show_sidebars',$_POST['alwayssidebars']   );
        royale_set_var('author_comments'     ,$_POST['authorcomments']   );
        royale_set_var('title_scheme_index'   ,royale_escape($_POST['title_scheme_index']   ));
        royale_set_var('title_scheme_single'  ,royale_escape($_POST['title_scheme_single']  ));
        royale_set_var('title_scheme_page'    ,royale_escape($_POST['title_scheme_page']    ));
        royale_set_var('title_scheme_category',royale_escape($_POST['title_scheme_category']));
        royale_set_var('title_scheme_date'    ,royale_escape($_POST['title_scheme_date']    ));
        royale_set_var('title_scheme_search'  ,royale_escape($_POST['title_scheme_search']  ));
      }
      $dates           = get_option('royale_dates'          );
      $exclude         = split(",",get_option('royale_exclude_pages'));
      $sidebar1        = get_option('royale_sidebar1_left'  );
      $sidebar2        = get_option('royale_sidebar2_left'  );
      $hue             = get_option('royale_hue'            );
      $overlay_opacity = get_option('royale_overlay_opacity');
      $bgpattern       = get_option('royale_bgpattern'      );

      $pages = & get_pages('sort_column=menu_order');
      foreach ($pages as $page) {
        if (!$page->post_parent) { $pages_select .= '<input type="checkbox" name="exclude_'. $page->ID .'"'. (array_search($page->ID, $exclude) ? ' checked' : '') .' /> '. $page->post_title . '<br />'; }
      }

      $patterns_dir = opendir(TEMPLATEPATH .'/images/patterns/');
      while (false !== ($pattern = readdir($patterns_dir))) {
        if (preg_match("/\.(?:jpe?g|gif|png|bmp)$/i",$pattern)) {
          $patterns .= '<input type="radio" name="bgpattern" value="'.$pattern.'"'. ($bgpattern == $pattern ? ' checked="checked"' : '') .' /><img src="'. get_bloginfo('stylesheet_directory').'/images/patterns/'.$pattern.'" title="'. $pattern .'" style="width: 100px; height: 100px" /> ';
        }
      }

      echo '
		<p align="center"><a href="#versioncheck">Are you using the latest version?</a> - <a href="http://www.onehertz.com/portfolio/wordpress/donate/" title="Show your support, please make a donation" target="_blank">Enjoy Royale? Please consider making a donation.</a></p>
		<div class="wrap">
		<h2>Royale Options</h2>
		
		<form name="royale_options_form" method="post" action="?page=functions.php">
		<input type="hidden" name="updated" value="1" />
		<p class="submit"><input type="submit" name="Submit" value="'.__('Update Options &raquo;').'"/></p>

		
		<fieldset class="options">
		<legend>Layout Options</legend>
		<label><b>Columns</b></label><br />
		<input type="checkbox" name="col3" '. (get_option('royale_3columns') ? 'checked="checked"' : '') .' /> Use the 3-column layout<br />
		<input type="checkbox" name="alwayssidebars" '. (get_option('royale_always_show_sidebars') ? 'checked="checked"' : '') .' /> Show sidebars even in single post view<br /><br />
		<label><b>Sidebars position</b></label><br/>
		<table border=0>
			<tr>
				<td align="right">First sidebar :</td>
				<td>
					<input type="radio" name="sidebar1" value="1"  '. ($sidebar1 ? 'checked="checked"' : '') .' />left &nbsp; 
					<input type="radio" name="sidebar1" value="0"  '. ($sidebar1 ? '' : 'checked="checked"') .' />right
				</td>
			</tr>
			<tr>
				<td align="right">Second sidebar :</td>
				<td>
					<input type="radio" name="sidebar2" value="1"  '. ($sidebar2 ? 'checked="checked"' : '') .' />left &nbsp; 
					<input type="radio" name="sidebar2" value="0"  '. ($sidebar2 ? '' : 'checked="checked"') .' />right
				</td>
			</tr>
		</table>
		<br />
					
		<label><b>Colors</b></label><br />
		Hue: <img src="'. get_bloginfo('template_directory') .'/images/hue.jpg" alt="" id="hues" style="width: 360px; height: 8px;" /><img src="'. get_bloginfo('template_directory') .'/images/handle.gif" alt="" id="handle" style="width: 9px; height: 8px; cursor: pointer;" /> <input type="text" id="huev" name="huev" value="'. $hue .'" size="3" disabled style="textalign: center; font-weight: bold;" />&deg;<br />
		<input type="hidden" name="hue" value="'.$hue.'" /> <input type="hidden" name="rgb1" value="'. get_option('royale_rgb1') .'" /><input type="hidden" name="rgb2" value="'. get_option('royale_rgb2') .'" />
		<input type="checkbox" name="cycle" '. (get_option('royale_hue_cycle') ? 'checked="checked"' : '') .' /> I can\'t decide, cycle colors automatically<br /><br />

		<label><b>Background Opacity</b></label><br />
		Black background opacity: 
		<input type="radio" name="overlay_opacity" value="25"  '. ($overlay_opacity == 25 ? 'checked="checked"' : '') .' />25% &nbsp; 
		<input type="radio" name="overlay_opacity" value="50"  '. ($overlay_opacity == 50 ? 'checked="checked"' : '') .' />50%<br /><br />

		<label><b>Background Pattern</b></label><br />
		'. $patterns .'
		</fieldset>


		<fieldset class="options">
		<legend>SEO Options</legend>

		<label><b>Custom &lt;title&gt; tags</b></label><br/>
		Customize your title tag. Consult the <a href="themes.php?page=README">README page</a> for a list of available variables.
		<table>
			<tr>
				<td style="text-align: right;">Default (index.php):</td>
				<td><input type="text" name="title_scheme_index" size="60" value="'. get_option('royale_title_scheme_index') .'" /></td>
			</tr>
			<tr>
				<td style="text-align: right;">Single posts (single.php):</td>
				<td><input type="text" name="title_scheme_single" size="60" value="'. get_option('royale_title_scheme_single') .'" /></td>
			</tr>
			<tr>
				<td style="text-align: right;">Pages (page.php):</td>
				<td><input type="text" name="title_scheme_page" size="60" value="'. get_option('royale_title_scheme_page') .'" /></td>
			</tr>
			<tr>
				<td style="text-align: right;">Category Archive (archive.php):</td>
				<td><input type="text" name="title_scheme_category" size="60" value="'. get_option('royale_title_scheme_category') .'" /></td>
			</tr>
			<tr>
				<td style="text-align: right;">Date Archive (archive.php):</td>
				<td><input type="text" name="title_scheme_date" size="60" value="'. get_option('royale_title_scheme_date') .'" /></td>
			</tr>
			<tr>
				<td style="text-align: right;">Search Results (search.php):</td>
				<td><input type="text" name="title_scheme_search" size="60" value="'. get_option('royale_title_scheme_search') .'" /></td>
			</tr>
		</table>
		</fieldset>


		<fieldset class="options">
		<legend>Miscellaneous Options</legend>
		<label><b>Pages to Exclude from Header Navigation</b></label><br />
		'. $pages_select .'<br />

		<label><b>Readability</b></label><br/>
		<input type="checkbox" name="boldlinks" '. (get_option('royale_bold_links') ? 'checked="checked"' : '') .' /> Display all links in bold for better readability<br /><br /> 
					
		<label><b>Date Format</b></label><br/>
		<input type="radio" name="dates" value="0"  '. ($dates ? '' : 'checked="checked"') .' />dd/mm/yyyy &nbsp; 
		<input type="radio" name="dates" value="1"  '. ($dates ? 'checked="checked"' : '') .' />month/dd/yyyy<br /><br />

		<label><b>Really miscellaneous options</b></label><br/>
		<input type="checkbox" name="fullsearchresults" '. (get_option('royale_full_search_results') ? 'checked="checked"' : '') .' /> Display full search results, not just titles and metadata<br />
		<input type="checkbox" name="authorcomments" '. (get_option('royale_author_comments') ? 'checked="checked"' : '') .' /> Highlight comments made by the author of the current post<br />
		<input type="checkbox" name="nofloat" '. (get_option('royale_nofloat') ? 'checked="checked"' : '') .' /> Do not wrap text around images<br />
		<input type="checkbox" name="footstats" '. (get_option('royale_footer_stats') ? 'checked="checked"' : '') .' /> Display rendering time and SQL statistics in the footer<br />
		<input type="checkbox" name="em" '. (get_option('royale_em_italics') ? 'checked="checked"' : '') .' /> Display &lt;em&gt; tags as italics
		</fieldset>

		<p class="submit"><input type="submit" name="Submit" value="'.__('Update Options &raquo;').'"/></p>
		</form>

		<h2 id="versioncheck">Version Checker</h2>
		<iframe src="http://www.onehertz.com/cgi-bin/wordpress:versioncheck.pl?theme=Royale&amp;version='. $ct->version .'" width="100%" height="90" scrolling="auto" frameborder="0"></iframe>

		</div>

		<div id="preview" class="wrap">
		<h2 id="preview-post">Preview (updated when options are saved)</h2>
		<iframe src="../?preview=true" width="100%" height="600" ></iframe>
		</div>

<script type="text/javascript">
function hsv2rgb(h,s,v) {
  hi = Math.floor(h/60) % 6;
  f  = h/60-hi;
  p  = v*(1-s);
  q  = v*(1-f*s);
  t  = v*(1-(1-f)*s);
  switch (hi) {
    case 0:
     r = v; g = t; b = p;
     break;
    case 1:
     r = q; g = v; b = p;
     break;
    case 2:
     r = p; g = v; b = t;
     break;
    case 3:
     r = p; g = q; b = v;
     break;
    case 4:
     r = t; g = p; b = v;
     break;
    case 5:
     r = v; g = p; b = q;
     break;
  }
  return \'rgb(\'+Math.round(r*256)+\',\'+Math.round(g*256)+\',\'+Math.round(b*256)+\')\';
}

o = document.getElementById(\'handle\');
hx = o.offsetLeft;
hy = o.offsetTop;
while (o = o.offsetParent) {
  hx += o.offsetLeft;
  hy += o.offsetTop;
}
document.getElementById(\'handle\').style.position = \'absolute\';
document.getElementById(\'handle\').style.left = hx-359+'.$hue.'+\'px\';
document.getElementById(\'handle\').style.top  = hy-5+\'px\';

mdown = function(e) {
  d = '.($ie || $ie7 ? "window.event.srcElement" : "e.target").';
  x = '.($ie || $ie7 ? "window.event.clientX"    : "e.clientX").';
  if (d.id == \'handle\') {
    drag = 1;
    dx = d.offsetLeft;
    document.onmousemove = mmove;
    return false;
  }
}
mup = function() { drag = 0; document.onmousemouve = null; }
mmove = function(e) {
  if (drag) {
    var nx = dx + '.($ie || $ie7 ? "window.event.clientX"    : "e.clientX").' - x;
    if (nx >= hx-359-5 && nx <= hx-5) {
      d.style.left = nx + \'px\';
      nh = nx-hx+359+5;
      updatehue(nh);
    }
    return false;
  }
}
updatehue = function(t) {
  var rgb1 = hsv2rgb(t,0.91,0.91);
  var rgb2 = hsv2rgb(t,0.25,0.95);
  document.forms.royale_options_form.huev.value = t;
  document.forms.royale_options_form.hue.value  = t;
  document.forms.royale_options_form.rgb1.value = rgb1;
  document.forms.royale_options_form.rgb2.value = rgb2;
  document.getElementById(\'huev\').style.backgroundColor = rgb1;
}
document.onmousedown = mdown;
document.onmouseup   = mup;
updatehue('.$hue.');
</script>
      ';
    }	
  }

  function royale_set_insert($key,$value)  { update_option('royale_inserts_'.$key,str_replace("\\","",$value)); }
  function royale_inserts_page() {
    if (isset($_POST['updated'])) {
      royale_set_insert('header',$_POST['header']);
      royale_set_insert('body'  ,$_POST['body']  );
      royale_set_insert('top'   ,$_POST['top']   );
      royale_set_insert('footer',$_POST['footer']);
    }

    echo '
		<div class="wrap">
		<h2>Royale Options</h2>
		
		<form name="royale_options_form" method="post" action="?page=Inserts">
		<input type="hidden" name="updated" value="1" />
		
		<fieldset class="options">
		<legend>HTML Inserts</legend>

		<p>The fields on this page allow you to save pieces of code required by third-party plugins and widgets. You can also use them to save Google Maps/Analytics/AdSense javascript snippets, or whatever you want. This way you will never have to insert code manually each time you update Royale.</p>

		<p>NO validation is made on the field values, so be careful not to paste invalid code. Also note that backslashes will be stripped.</p>

		<label><b>header.php</b></label><br/>
                right before &lt;/HEAD&gt; (<i>useful for links to external stylesheets, javascript files, or inline CSS</i>):<br />
		<textarea name="header" rows=7 style="width: 100%">'. str_replace("\\","",get_option('royale_inserts_header')) .'</textarea><br /><br />

                custom &lt;BODY&gt; tag (<i>useful for onload actions</i>):<br />
		<textarea name="body" rows=1 style="width: 100%">'. str_replace("\\","",get_option('royale_inserts_body')) .'</textarea><br />
		<small>NOTE: if you are using the link color-cycling feature, you must place a call to royale_init() in your onload event</small><br /><br />

                right before the content and sidebars area. This differs from the top widget container in that it displays on all pages, and it spans the whole layout width.<br />
		<textarea name="top" rows=7 style="width: 100%">'. str_replace("\\","",get_option('royale_inserts_top')) .'</textarea><br /><br />

		<label><b>footer.php</b></label><br/>
                before the "Powered by WordPress" credits, still inside the #main div. This differs from the bottom widget container in that it displays on all pages, and it spans the whole layout width.<br />
		<textarea name="footer" rows=7 style="width: 100%">'. str_replace("\\","",get_option('royale_inserts_footer')) .'</textarea>
		</fieldset>
					
		<p class="submit"><input type="submit" name="Submit" value="'.__('Update Inserts &raquo;').'"/></p>
		</form>
		</div>
    ';
  }

  function royale_readme_page() {
    echo '<div class="wrap">';
    echo '<pre>';
    include("README.txt");
    echo '</pre>';
    echo '</div>';
  }
?>
