<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head profile="http://gmpg.org/xfn/11">
<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php bloginfo('charset'); ?>" />

<title><?php
  $title = '';

      if (is_single() ) $title = get_option('royale_title_scheme_single');
  elseif (is_page()   ) $title = get_option('royale_title_scheme_page');
  elseif (is_archive()) {
    if (is_day() || is_month() || is_year()) $title = get_option('royale_title_scheme_date');
    else                                     $title = get_option('royale_title_scheme_category');
  }
  elseif (is_search() ) $title = get_option('royale_title_scheme_search');
  else                  $title = get_option('royale_title_scheme_index');

  $title = str_replace('%blogname%',get_bloginfo('name')       ,$title);
  $title = str_replace('%tagline%' ,get_bloginfo('description'),$title);
  $title = str_replace('%post%'    ,get_the_title()            ,$title);
  $title = str_replace('%search%'  ,$s                         ,$title);

  if (single_cat_title('',false)) $title = str_replace('%category%',single_cat_title('',false) ,$title);
  else                            $title = preg_replace("/<[^>]+>/","",str_replace('%category%',get_the_category_list(', '),$title));

  if     (is_day()  ) $title = str_replace('%date%',get_the_time(__('l, F jS, Y','royale')),$title);
  elseif (is_month()) $title = str_replace('%date%',get_the_time(__('F, Y','royale'))      ,$title);
  elseif (is_year() ) $title = str_replace('%date%',get_the_time('Y')                       ,$title);

  echo $title;
?></title>

<meta name="generator" content="WordPress <?php bloginfo('version'); ?>" /> <!-- leave this for stats -->
<meta name="theme"     content="Royale <?php $themes = get_themes(); echo $themes['Royale']['Version']; ?>" />

<link rel="stylesheet" href="<?php echo get_bloginfo('stylesheet_url'); ?>.php" type="text/css" media="screen" />
<link rel="alternate" type="application/rss+xml" title="<?php bloginfo('name'); ?> RSS Feed" href="<?php bloginfo('rss2_url'); ?>" />
<link rel="pingback" href="<?php bloginfo('pingback_url'); ?>" />
<?php
  wp_head();
  if (get_option('royale_bold_links')) { $lastminutecss .= "  a { font-weight: bold; }\n"; };
  if ($lastminutecss) {  echo "<style type=\"text/css\">\n$lastminutecss</style>\n"; }

  $hue0  = get_option('royale_hue');
  if (!$hue0) { $hue0 = 201; }
  $rgb10 = get_option('royale_rgb1');
  $rgb20 = get_option('royale_rgb2');
?>

<script type="text/javascript">
var h, s, v, r, g, b, hi, f, p, q, t;

function dec2hex(n) {
  var str = "";
  while (n) { str = "0123456789ABCDEF".charAt(n&0xf) + str; n>>>=4; }
  return (str.length ? str : 0);
}

function hsv2rgb(h,s,v) {
  hi = Math.floor(h/60) % 6;
  f  = h/60-hi;
  p  = v*(1-s);
  q  = v*(1-f*s);
  t  = v*(1-(1-f)*s);
  switch (hi) {
    case 0:
     r = v; g = t; b = p;
     break;
    case 1:
     r = q; g = v; b = p;
     break;
    case 2:
     r = p; g = v; b = t;
     break;
    case 3:
     r = p; g = q; b = v;
     break;
    case 4:
     r = t; g = p; b = v;
     break;
    case 5:
     r = v; g = p; b = q;
     break;
  }
  return 'rgb('+Math.round(r*256)+','+Math.round(g*256)+','+Math.round(b*256)+')';
}

var hue = <?php echo $hue0; ?>;
function huecycle() {
  hueshift();
  if (!hue--) { hue += 360; }
  setTimeout("huecycle()",1000);
}

elements = new Array();
props    = new Array('color','borderBottom','borderTop');
rules    = (/MSIE/i.test(navigator.userAgent) ? 'rules' : 'cssRules');

function hueshift() {
  var nrgb1 = hsv2rgb(hue,0.91,0.91);
  var nrgb2 = hsv2rgb(hue,0.25,0.95);
  for (i=0;i<elements.length;i++) {
    if (/RGB1/.test(elements[i][3])) { document.styleSheets[elements[i][0]][rules][elements[i][1]].style[props[elements[i][2]]] = elements[i][3].replace(/RGB1/,nrgb1); }
    if (/RGB2/.test(elements[i][3])) { document.styleSheets[elements[i][0]][rules][elements[i][1]].style[props[elements[i][2]]] = elements[i][3].replace(/RGB2/,nrgb2); }
  }
}

function walkondom() {
  re1 = /<?php echo ereg_replace(',',',\\s*',ereg_replace('([\(\)])','\\\\1',$rgb10)); ?>/i;
  re2 = /<?php echo ereg_replace(',',',\\s*',ereg_replace('([\(\)])','\\\\1',$rgb20)); ?>/i;
  for (i=0;i<document.styleSheets.length;i++) {
    for (j=0;j<document.styleSheets[i][rules].length;j++) {
      if (document.styleSheets[i][rules][j].type == 1) {
        if (document.styleSheets[i][rules][j].style['marks']) {
          for (k=0;k<props.length;k++) {
            if (re1.test(document.styleSheets[i][rules][j].style[props[k]])) {
              elements[elements.length++] = new Array(i,j,k,document.styleSheets[i][rules][j].style[props[k]].replace(re1,'RGB1'));
            }
            if (re2.test(document.styleSheets[i][rules][j].style[props[k]])) {
              elements[elements.length++] = new Array(i,j,k,document.styleSheets[i][rules][j].style[props[k]].replace(re2,'RGB2'));
            }
          }
        }
      }
    }
  }
}
function royale_init() {
<?php if (get_option('royale_hue_cycle')): ?>
  walkondom();
  huecycle();
<?php endif; ?>
}
</script>
<?php echo get_option('royale_inserts_header'); ?>

</head>
<?php
 $bodytag = get_option('royale_inserts_body');
 echo (preg_match("/<body/i",$bodytag) ? $bodytag : "<body onload=\"royale_init()\">");
?>

<div id="header">
	<h1><a href="<?php echo get_option('home'); ?>/"><?php bloginfo('name'); ?></a></h1>
	<div class="description"><?php bloginfo('description'); ?></div>
	<ul class="pages">
		<li class="page_item"><a href="<?php echo get_option('home'); ?>/"><?php _e('Home','royale'); ?></a></li>
		<?php wp_list_pages('sort_column=menu_order&depth=1&title_li=&exclude='.get_option('royale_exclude_pages')); ?>
	</ul>
</div>
<div id="page">
<?php echo get_option('royale_inserts_top'); ?>
<table>
<tr>
